# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-ExtUtils-CBuilder
Epoch:		1
Version:	0.280235
Release:	1.%{__distinit}%{__distvers}
Summary:	Compile and link C code for Perl modules
License:	GPL+ or Artistic
URL:		https://metacpan.org/release/ExtUtils-CBuilder
Source0:	https://cpan.metacpan.org/modules/by-module/ExtUtils/ExtUtils-CBuilder-%{version}.tar.gz
Patch0:		ExtUtils-CBuilder-0.280231-Link-XS-modules-to-libperl.so-with-EU-CBuilder-on-Li.patch
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.30
# Module Runtime
BuildRequires:	perl(Config)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(DynaLoader)
BuildRequires:	perl(ExtUtils::Mksymlists)
BuildRequires:	perl(File::Basename)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(IO::File)
BuildRequires:	perl(IPC::Cmd)
BuildRequires:	perl(Perl::OSType) >= 1
BuildRequires:	perl(strict)
BuildRequires:	perl(Text::ParseWords)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	gcc-c++
BuildRequires:	perl(Test::More)
# Extra Tests
BuildRequires:	perl(Test::Pod) >= 1.41
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	gcc
Requires:	perl-devel
Requires:	perl(DynaLoader)
Requires:	perl(ExtUtils::Mksymlists)

%description
This module can build the C portions of Perl modules by invoking the
appropriate compilers and linkers in a cross-platform manner. It was
motivated by the Module::Build project, but may be useful for other
purposes as well.

%prep
%setup -q -n ExtUtils-CBuilder-%{version}

# Link XS modules to libperl.so with EU::CBuilder on Linux (#960048)
%if 0%{?fedora} > 19 || 0%{?rhel} > 7
%patch0 -p1
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test
make test TEST_FILES="$(echo $(find xt/ -name '*.t'))"

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes CONTRIBUTING README README.mkdn
%{perl_vendorlib}/ExtUtils/
%{_mandir}/man3/ExtUtils::CBuilder.3*
%{_mandir}/man3/ExtUtils::CBuilder::Platform::Windows.3*

%changelog
* Mon Nov  2 2020 Paul Howarth <paul@city-fan.org> - 1:0.280235-1
- Update to 0.280235
  - Fix compilation on darwin with XCode 12
    (-Werror=implicit-function-declaration) 

* Tue Jan 21 2020 Paul Howarth <paul@city-fan.org> - 1:0.280234-1
- Update to 0.280234
  - Updated standalone module from blead

* Mon Apr  1 2019 Paul Howarth <paul@city-fan.org> - 1:0.280231-1
- Update to 0.280231
  - Protected RE interpolation in Base.pm
- Switch upstream from search.cpan.org to metacpan.org
- BR: gcc-c++ for test suite

* Tue Feb 20 2018 Paul Howarth <paul@city-fan.org> - 1:0.280230-3
- Add dependency on gcc (#1547165)

* Mon Dec 18 2017 Paul Howarth <paul@city-fan.org> - 1:0.280230-2
- Link XS modules to libperl.so with EU::CBuilder on Linux (#960048)

* Thu Nov 23 2017 Paul Howarth <paul@city-fan.org> - 1:0.280230-1
- Update to 0.280230
  - Restore compatibility of test suite with Perl 5.6
  - Fix link() on Windows, broken in version 0.280226
  - Remove dependency on 'vars' package
  - Used OurPkgVersion instead of PkgVersion
- Explicitly require perl-devel

* Fri Jul 14 2017 Paul Howarth <paul@city-fan.org> - 1:0.280226-1
- Update to 0.280226
  - New location of libperl on Win32 when building core (CPAN RT#126632)
  - Fix C++ compiler detection (CPAN RT#131749)
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Mon Aug 22 2016 Paul Howarth <paul@city-fan.org> - 1:0.280224-2
- BR: perl-generators where available
- Simplify find command using -delete

* Sat Oct 10 2015 Paul Howarth <paul@city-fan.org> - 1:0.280224-1
- Update to 0.280224
  - Use warnings/strict on all modules

* Fri Jul  3 2015 Paul Howarth <paul@city-fan.org> - 1:0.280223-3
- Update to 0.280223
  - Impose deterministic order on cpp-definition options (CPAN RT#124106)
  - Add tests for ascii-betical order in t/04-base.t
- Abandon efforts to retain two-digit version number

* Tue Sep 30 2014 Paul Howarth <paul@city-fan.org> - 1:0.28-20
- Update to 0.280220
  - Added missing 'use Config' to 'android.pm'
- Classify buildreqs by usage

* Fri Sep  5 2014 Paul Howarth <paul@city-fan.org> - 1:0.28-19
- Update to 0.280219
  - Quoted perl path for Windows support (CPAN RT#98245)
  - Mis-spelled 'starup' key in BCC support was fixed (CPAN RT#79574)
  - Fixed the version in the PM file
  - Fixed regression on Android
- Dropped support for building with ExtUtils::MakeMaker < 6.30

* Thu Aug 28 2014 Paul Howarth <paul@city-fan.org> - 1:0.28-16
- Use %%license where possible
- Drop %%defattr, redundant since rpm 4.4

* Sat Mar  8 2014 Paul Howarth <paul@city-fan.org> - 1:0.28-15
- Update to 0.280216
  - Android support
  - Teach ExtUtils::CBuilder to handle mod2fname properly

* Sun Sep  8 2013 Paul Howarth <paul@city-fan.org> - 1:0.28-12
- Update to 0.280212
  - Missing dependency Perl::OSType
  - Fixed repository location
  - Reversion all modules
- Drop UTF8 patch, no longer needed

* Fri Sep  6 2013 Paul Howarth <paul@city-fan.org> - 1:0.28-10
- Update to 0.280210
  - Added a SUPPORT section to indicate that upstream is Perl 5 core
  - Corrected test for existence of manifest file on Windows (Perl RT#111782)
  - Corrected location in which manifest file is looked for on Windows
    (CPAN RT#35943, Perl RT#111798)
  - Allow options to be passed to prelink in Windows (Perl RT#115100)
  - Update INSTALLDIRS to favour installation under 'site' (Perl RT#116479)
- This release by AMBS -> update source URL
- Update patch for building with old ExtUtils::MakeMaker
- Explicitly run the extra tests
- Package the README* files
- Drop BR: perl(Data::Dumper), no longer needed

* Fri Jun  8 2012 Paul Howarth <paul@city-fan.org> - 1:0.28-9
- BR: perl(Config) and perl(Data::Dumper)
- Don't need to remove empty directories from buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Thu Feb 23 2012 Paul Howarth <paul@city-fan.org> - 1:0.28-8
- Update to 0.280205
  - Refactored OS name mapping to use Perl::OSType
  - Appends CFLAGS and LDFLAGS environments instead of overriding
  - Reset ccflags on compilation for VMS.
  - Fixed bug picking up ccflags from Config
  - Quotation style cleanup
- BR: perl(Cwd), perl(File::Basename), perl(File::Spec), perl(File::Temp),
  perl(IO::File), perl(Perl::OSType) and perl(Text::ParseWords)
- Update patch for building with old ExtUtils::MakeMaker
- Upstream no longer shipping README

* Mon Oct 17 2011 Paul Howarth <paul@city-fan.org> - 1:0.28-7
- Use a patch rather than scripted iconv to fix character encoding
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun 24 2011 Paul Howarth <paul@city-fan.org> - 1:0.28-6
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands

* Mon Jan 24 2011 Paul Howarth <paul@city-fan.org> - 1:0.28-5
- Update to 0.280202
  - Different file names used for test files; allows EU::CB tests to be run in
    parallel

* Sun Jan 23 2011 Paul Howarth <paul@city-fan.org> - 1:0.28-4
- Update to 0.280201
  - t/04-base.t no longer attempts to compile or link as this provokes failures
    on main platforms
  - Various typo fixes in Pod or comments
- Package LICENSE and README
- Add patch for building with ExtUtils::MakeMaker < 6.31

* Sun Dec 12 2010 Paul Howarth <paul@city-fan.org> - 1:0.28-3
- Update to 0.2802
  - Incorporated another t/04-base.t fix from bleadperl

* Thu Dec  9 2010 Paul Howarth <paul@city-fan.org> - 1:0.28-2
- Update to 0.2801
  - Fixed spurious t/04-base.t failure when run from Perl core

* Wed Dec  8 2010 Paul Howarth <paul@city-fan.org> - 1:0.28-1
- Update to 0.2800
  - Code base modernization and substantial code coverage improvements
  - Rely on File::Temp::tempfile and File::Spec::tmpdir to get unique file
    name for checking for compiler
  - Handle C compiler and C++ compiler separately
  - Tests no longer fail if user has set the CC environment variable
  - Fix Win32 split_like_shell escaping
  - Fix t/02-link.t on perl < 5.8
  - Preserve exit status on VMS
- Bump epoch to 1 as per the Fedora package
- BR: perl(IPC::Cmd)

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 0.27-6
- Rebuild for perl 5.12.1 in Rawhide

* Mon Jun  7 2010 Paul Howarth <paul@city-fan.org> - 0.27-5
- Fix dist tag for RHEL-6 Beta

* Wed Mar 17 2010 Paul Howarth <paul@city-fan.org> - 0.27-4
- Update to 0.2703 (fixed tests for Windows and MSVC)

* Tue Feb 23 2010 Paul Howarth <paul@city-fan.org> - 0.27-3
- Update to 0.2702 (compile() changes in 0.2701 fixed to work on Windows too)

* Wed Feb 17 2010 Paul Howarth <paul@city-fan.org> - 0.27-2
- Update to 0.2701 (compile() now accepts both string and array for
  'include_dirs' argument, as documented - CPAN RT#54606)
- Recode Changes as UTF-8
- Dist tag for Rawhide no longer needs special-casing
- Use %%{_fixperms} macro instead of our own %%{__chmod} incantation

* Fri Oct 30 2009 Paul Howarth <paul@city-fan.org> - 0.27-1
- Update to 0.27
  - removed Build.PL to avoid creating a circular dependency
  - lots of fixes for Windows platform
  - added 'have_cplusplus()' method to check for C++ support
  - made have_compiler (and have_cplusplus) quiet
  - allow CC environment variable to override $Config{cc}

* Tue Sep  1 2009 Paul Howarth <paul@city-fan.org> - 0.26-5
- Update to 0.260301 (fix linking error on Win32 with gcc compiler (RT#49000))

* Mon Jul 27 2009 Paul Howarth <paul@city-fan.org> - 0.26-4
- Update to 0.2603 (fix INSTALLDIRS setting for older Perls (RT#47985))

* Sat Jul  4 2009 Paul Howarth <paul@city-fan.org> - 0.26-3
- Update to 0.2602 (fixed 00-have-compiler.t if $^X is a relative path)

* Thu Jul  2 2009 Paul Howarth <paul@city-fan.org> - 0.26-2
- Update to 0.2601 (fixes for VMS build; RPM version not changed because perl
  module versioning doesn't work like RPM package versioning)

* Tue Jun 30 2009 Paul Howarth <paul@city-fan.org> - 0.26-1
- Update to 0.26 (use Test::More, test for have_compiler)

* Mon Jun 29 2009 Paul Howarth <paul@city-fan.org> - 0.25-1
- Update to 0.25 (changes for non-Linux platforms)
- Define RPM macros in global scope
- New upstream maintainer -> new source URL

* Mon Aug 18 2008 Paul Howarth <paul@city-fan.org> - 0.24-1
- Update to 0.24
- Tweak dist tag macros to work on current Rawhide with three-part releasenum

* Mon Apr 21 2008 Paul Howarth <paul@city-fan.org> - 0.23-1
- Update to 0.23

* Mon Feb 11 2008 Paul Howarth <paul@city-fan.org> - 0.22-1
- Update to 0.22

* Wed Oct 31 2007 Paul Howarth <paul@city-fan.org> - 0.21-1
- Update to 0.21
- Unexpand tabs in spec
- Clarify license as GPL version 1or later, or Artistic (i.e. same as perl)

* Mon May 14 2007 Paul Howarth <paul@city-fan.org> - 0.19-1
- Update to 0.19

* Sun Mar 18 2007 Paul Howarth <paul@city-fan.org> - 0.18-2
- Fix dist tag for development builds
- Buildrequire perl(ExtUtils::MakeMaker)
- Fix argument order for find with -depth

* Mon Mar 27 2006 Paul Howarth <paul@city-fan.org> - 0.18-1
- Update to 0.18

* Thu Mar 16 2006 Paul Howarth <paul@city-fan.org> - 0.17-1
- Update to 0.17

* Tue Mar 14 2006 Paul Howarth <paul@city-fan.org> - 0.16-1
- Update to 0.16

* Fri Mar  3 2006 Paul Howarth <paul@city-fan.org> - 0.15-1
- Import from Fedora Extras
